<script setup lang="ts">
import axios from "axios";
import { nextTick, ref } from "vue";
import router from "../router/index";
import { useCookies } from "vue3-cookies";

const backendURL = import.meta.env.VITE_BACKEND_URL;

const { cookies } = useCookies();
let file = ref();
let thumb = ref();
let fileSrc = ref("");
let thumbSrc = ref("");
let showEmbed = ref(false);
let showThumb = ref(false);
let error = ref();

const onChangeFile = async (e: Event) => {
  const files = (<HTMLInputElement>e?.target).files?.[0];
  file.value = files;
  fileSrc.value = URL.createObjectURL(files!);
  showEmbed.value = true;
  await nextTick();
};

const onChangeThumb = async (e: Event) => {
  const thumbs = (<HTMLInputElement>e?.target).files?.[0];
  thumb.value = thumbs;
  thumbSrc.value = URL.createObjectURL(thumbs!);
  showThumb.value = true;
  await nextTick();
};

const sendInfoForm = async () => {
  if (!showEmbed.value) {
    error.value = "File belum diupload.";
    setTimeout(() => {
      error.value = null;
    }, 3000);
  }

  const formData = new FormData(
    <HTMLFormElement>document.getElementById("info-form-corpus")
  );

  formData.append("files", file.value);
  formData.append("img", thumb.value);

  try {
    await axios({
      method: "post",
      url: `${backendURL}/kitab/create`,
      data: formData,
      headers: { 
        "Content-Type": "multipart/form-data",
        "authorization": 'Bearer ' + cookies.get("authorization")
        
        },
    });
    router.push("/corpus");
  } catch (err) {
    error.value = err;
    setTimeout(() => {
      error.value = null;
    }, 3000);
  }
};
</script>

<template>
  <div class="animate__animated animate__fadeIn">
    <div class="flex flex-col md:grid md:grid-cols-2 gap-2">
      <div class="p-6">
        <div id="error-verify" class="text-red-500 ml-8">{{ error }}</div>
        <form id="file-form-corpus" class="h-full md:pl-5 pr-6">
          <div class="flex justify-between ...">
            <p class="label-regis-login ml-4 mb-2">
              File Korpus<span style="color: red"> *</span>
            </p>
            <button
              @click="showEmbed = false"
              v-if="showEmbed"
              class="navbutton text-white mb-2"
            >
              Hapus PDF
            </button>
          </div>

          <label class="w-full mb-6 label-box-file-corpus">
            <button
              v-if="!showEmbed"
              class="navbutton text-white h-10 w-60 button-box-file-corpus"
              disabled
            >
              Upload PDF
            </button>
            <input
              @change="onChangeFile"
              id="input-file"
              v-if="!showEmbed"
              type="file"
              accept=".pdf"
              class="input-box-file-corpus"
            />

            <embed
              id="embed-file-corpus"
              v-if="showEmbed"
              type="application/pdf"
              :src="fileSrc"
              width="100%"
              height="100%"
            />
          </label>
          <div class="flex justify-between ...">
            <p class="label-regis-login ml-4 mb-2">Halaman Sampul</p>
            <button
              @click="showThumb = false"
              v-if="showThumb"
              class="navbutton text-white mb-2"
            >
              Hapus Gambar
            </button>
          </div>
          <label class="w-full mb-6 label-box-thumb-corpus">
            <button
              v-if="!showThumb"
              class="navbutton text-white h-10 w-80 button-box-file-corpus"
              disabled
            >
              Upload Gambar
            </button>
            <input
              @change="onChangeThumb"
              id="input-thumb"
              v-if="!showThumb"
              type="file"
              accept="image/*"
              class="input-box-file-corpus"
            />

            <img
              v-if="showThumb"
              class="input-box-file-corpus"
              style="object-fit: contain"
              :src="thumbSrc"
              alt="Halaman sampul yang di-Upload"
            />
          </label>
        </form>
      </div>
      <div id="right-side" class="grid grid-cols-2 content-center md:px-6 py-5">
        <form
          id="info-form-corpus"
          @submit.prevent="sendInfoForm"
          class="col-span-2 px-6"
        >
          <div class="field px-6">
            <div class="col-auto">
              <p class="label-regis-login">
                Judul<span style="color: red"> *</span>
              </p>
              <input
                id="input-title"
                type="text"
                name="title"
                placeholder="Transliterasi Pegon Bertahap"
                required
                class="input-box-form-corpus"
              />
            </div>

            <div class="col-span-1">
              <p class="label-regis-login">
                Bahasa<span style="color: red"> *</span>
              </p>
              <select
                id="input-language"
                name="language"
                class="input-box-form-corpus"
              >
                <option value="jawa">Jawa</option>
                <option value="sunda">Sunda</option>
                <option value="madura">Madura</option>
                <option value="indonesia">Indonesia</option>
              </select>
            </div>

            <div>
              <p class="label-regis-login">Penulis</p>
              <input
                id="input-author"
                type="text"
                name="author"
                placeholder="Asep Sutarma"
                class="input-box-form-corpus"
              />
            </div>

            <div>
              <p class="label-regis-login">Tanggal Ditulis</p>
              <input
                id="input-timeWritten"
                name="timeWritten"
                type="date"
                class="input-box-form-corpus"
                value="1970-01-01"
              />
            </div>
            <div>
              <p class="label-regis-login">Tempat Ditulis</p>
              <input
                id="input-locationWritten"
                name="locationWritten"
                type="text"
                placeholder="Magelang"
                class="input-box-form-corpus"
              />
            </div>

            <div class="col-span-1">
              <p class="label-regis-login">Jenis</p>
              <input
                id="input-type"
                name="type"
                type="text"
                placeholder="kitab kuning"
                class="input-box-form-corpus"
              />
            </div>
            <div>
              <p class="label-regis-login">Media</p>
              <input
                id="input-media"
                name="media"
                type="text"
                placeholder="daluang"
                class="input-box-form-corpus"
              />
            </div>

            <div>
              <p class="label-regis-login">Tinta</p>
              <input
                id="input-ink"
                name="ink"
                type="text"
                placeholder="masi"
                class="input-box-form-corpus"
              />
            </div>
            <div>
              <p class="label-regis-login">Iluminasi</p>
              <input
                id="input-illumination"
                name="illumination"
                type="text"
                placeholder="bingkai"
                class="input-box-form-corpus"
              />
            </div>

            <div>
              <p class="label-regis-login">Deskripsi</p>
              <textarea
                id="input-desc"
                name="desc"
                type="text"
                placeholder="Sebuah korpus peninggalan pada zaman dahulu"
                class="input-box-textarea-corpus"
              />
            </div>

            <button class="btn-regis-login" type="submit">Simpan</button>
          </div>
        </form>
      </div>
    </div>
  </div>
</template>

<style>
.input-box-form-corpus {
  color: white;
  background: #2d2e2d;
  border-radius: 10px;
  display: flex;
  min-width: 100%;
  min-height: 40px;
  color-scheme: dark;
  @apply mb-6 pl-3 pr-3;
}

.input-box-textarea-corpus {
  color: white;
  background: #2d2e2d;
  border-radius: 10px;
  display: flex;
  min-width: 100%;
  min-height: 40px;
  @apply mb-6 pl-3 pr-3 pt-2;
}

.label-box-file-corpus {
  background: #2d2e2d;
  border-radius: 15px;
  @apply [min-height:20rem] md:[height:59%];
}

.label-box-thumb-corpus {
  background: #2d2e2d;
  border-radius: 15px;
  @apply [min-height:20rem] md:[height:30%];
}

.input-box-file-corpus {
  background: #2d2e2d, transparent;
  border-radius: 10px;
  width: 100%;
  border: none;
}

.button-box-file-corpus {
  margin: 0;
  position: absolute;
  top: 50%;
  -ms-transform: translateY(-50%);
  transform: translateY(-50%);
}

select {
  border-right: 16px solid transparent
}
</style>
